<?php

	require_once 'woocommerce-smartroute-direct-post-helper.php';
	require_once 'woocommerce-smartroute-direct-post.php';
	
	global $woocommerce;
	session_start();

	$gateway = new SmartRoute_Direct_Post();
	$gateway->log('redirect response for order#'.$orderId.': '.json_encode($_REQUEST));

	$order = new WC_Order($_SESSION['order_id']);
	$_SESSION['smartRouteDirectPostEntered'] = true;

	$res_data = array();
        
	//get required params from response
	if (isset($_REQUEST['Response_StatusCode'])) {
		$res_data['Response_StatusCode'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_StatusCode']);
	}

	if (isset($_REQUEST['Response_StatusDescription'])) {
		$res_data['Response_StatusDescription'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_StatusDescription']);
                $statusDescription = $res_data['Response_StatusDescription'];
	}

	if (isset($_REQUEST['Response_Amount'])) {
		$res_data['Response_Amount'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_Amount']);
	}

	if (isset($_REQUEST['Response_CurrencyISOCode'])) {
		$res_data['Response_CurrencyISOCode'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_CurrencyISOCode']);
	}

	if (isset($_REQUEST['Response_MerchantID'])) {
		$res_data['Response_MerchantID'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_MerchantID']);
	}

	if (isset($_REQUEST['Response_TransactionID'])) {
		$res_data['Response_TransactionID'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_TransactionID']);
	}

	if (isset($_REQUEST['Response_MessageID'])) {
		$res_data['Response_MessageID'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_MessageID']);
	}
	//get optional params from response
	if (isset($_REQUEST['Response_CardExpiryDate'])) {
		$res_data['Response_CardExpiryDate'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_CardExpiryDate']);
	}

	if (isset($_REQUEST['Response_CardHolderName'])) {
		$res_data['Response_CardHolderName'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_CardHolderName']);
	}

	if (isset($_REQUEST['Response_CardNumber'])) {
		$res_data['Response_CardNumber'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_CardNumber']);
	}

	if (isset($_REQUEST['Response_GatewayStatusCode'])) {
		$res_data['Response_GatewayStatusCode'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_GatewayStatusCode']);
	}

	if (isset($_REQUEST['Response_GatewayStatusDescription'])) {
		$res_data['Response_GatewayStatusDescription'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_GatewayStatusDescription']);                
	}

	if (isset($_REQUEST['Response_GatewayName'])) {
		$res_data['Response_GatewayName'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_GatewayName']);
	}

	if (isset($_REQUEST['Response_RRN'])) {
		$res_data['Response_RRN'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_RRN']);
	}

	if (isset($_REQUEST['Response_ApprovalCode'])) {
		$res_data['Response_ApprovalCode'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_ApprovalCode']);
	}

	if (isset($_REQUEST['Response_Token'])) {
		$res_data['Response_Token'] = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_Token']);
	}

	// get the secure hash
	$res_secure_hash = SmartRoute_Direct_Post_Helper::checkIfNull($_REQUEST['Response_SecureHash']);
	$newSecureHash = SmartRoute_Direct_Post_Helper::generateDPSecureHash($res_data);
	
	$success = false;
	$is_inq = false;
        
	$gateway->log('order#'.$orderId.' status now is '.$order->get_status());
	if ($newSecureHash == $res_secure_hash) {
		$gateway->log('redirect secure hash for order#'.$orderId.' match successfully ');
		if ($res_data['Response_StatusCode'] == "00000") {
			$success = true;
		}
	} elseif($order->get_status() == 'pending'){
		$gateway->log('redirect secure hash for order#'.$orderId.
			" not match ".$secureHash." | ".$Response_SecureHash);
		//Inquiry Message
		$is_inq = true;
		$inq_url = trim(Smartroute_Direct_Post::$invalidSecureHashInquiryURL);

		$fields = array();
		$fields['MessageID'] = 2;
		$fields['MerchantID'] = $res_data['Response_MerchantID'];
		$fields['OriginalTransactionID'] = $res_data['Response_TransactionID'];
		$fields['SecureHash'] = SmartRoute_Direct_Post_Helper::generateDPSecureHash($fields);

		$gateway->log('redirect inquiry for order#'.$orderId.
			" : ".json_encode($fields).' [in redirect response file]');
		$inq_response = wp_remote_post($inq_url, array(
			'method' => 'POST',
			'body' => http_build_query($fields),
			'timeout' => 90,
			'sslverify' => false,
		));

		// Retrieve the body's resopnse if no errors found
		$inq_response_body = wp_remote_retrieve_body($inq_response);
		$gateway->log('redirect inquiry response for order#'.$orderId.
			" : ".$inq_response_body );

		// Parse the response into something we can read
		$inq_resp = array();
		parse_str($inq_response_body, $inq_resp);

                $inq_res_data = array_map(function($item){
                    return SmartRoute_Direct_Post_Helper::checkIfNull($item);
                },$inq_resp);
                unset($inq_res_data['Response_SecureHash']);
                
		//get required params from response
		

		// get the secure hash
		$res_secure_hash = SmartRoute_Direct_Post_Helper::checkIfNull($inq_resp['Response_SecureHash']);
		$newSecureHash = SmartRoute_Direct_Post_Helper::generateDPSecureHash($inq_res_data);
                
		if ($newSecureHash == $res_secure_hash) {
                        $statusDescription = $inq_res_data['Response_StatusDescription'];                        
			$gateway->log('inquiry status code for order#'.$orderId.'= '.$inq_res_data['Response_StatusCode']);
			if ($inq_res_data['Response_StatusCode'] == "00000") {
				$success = true;
			}
		} else {
			// do nothing
			$gateway->log('inquiry failed for order#'.$orderId.' secure hash not matched');
		}
	}elseif($order->get_status() == 'completed'){
            $gateway->log('order#'.$orderId.' is already completed');
            $success = true;
        }else{
            $gateway->log('order#'.$orderId.' is already '.$order->get_status());
            $success = false;
        }

	//update order status id
	if ($is_inq) {
		if($success){
			$order->update_status(SmartRoute_Direct_Post_Helper::getOrderStatusId($inq_res_data['Response_StatusCode']), isset($statusDescription)?$statusDescription:null);
		}else{ // If the inquiry response secure hash is not match, then update order status as  'pending'
			$order->update_status('pending','order_note');
		}
	} else {
		$order->update_status(SmartRoute_Direct_Post_Helper::getOrderStatusId($res_data['Response_StatusCode']),isset($statusDescription)?$statusDescription:null);
	}

	if ($success) {
		// Empty the cart (Very important step)
		$woocommerce->cart->empty_cart();

		$status_message = __($statusDescription, 'woocommerce-smartroute-direct-post-gateway');
		unset($_SESSION['smartRouteDirectPostEntered']);
		
                $old_wc = version_compare( WC_VERSION, '3.0', '<' );
                $order_total = $old_wc ? $order->order_total : $order->get_total();                
		SmartRoute_Direct_Post_Helper::smartroute_direct_post_form($status_message, $order->order_number, $order_total, $res_data['Response_TransactionID'], $order->get_status(),'message');
	} else {            
		// Transaction was not succesful
            
		//$status_message = __("Transaction was not successful. There is an error occurred.", 'woocommerce-smartroute-direct-post-gateway');
		$status_message = __($statusDescription, 'woocommerce-smartroute-direct-post-gateway');
		unset($_SESSION['smartRouteDirectPostEntered']);

		SmartRoute_Direct_Post_Helper::smartroute_direct_post_form($status_message, $order->order_number, '', $res_data['Response_TransactionID'], $order->get_status(),'error');
	}
        
?>
