<?php

class SmartRoute_Redirect_Helper {

    public static function checkIfNull($value) {
        if ($value == null || $value == "null" || $value == '') {
            return null;
        } else {
            return $value;
        }
    }

    //handle order status
    public static function getOrderStatusId($status_code) {
        $status = '';
        switch ($status_code) {
            case '10008':
                $status = "cancelled";
                break;
            case '00000':
                $status = "completed";
                break;

            case '20001':
                $status = "pending";
                break;

            case '20002':
                $status = "pending";
                break;

            case '':
                $status = "pending";
                break;

            default:
                $status = "failed";
                break;
        }
        return $status;
    }

    public static function generateRedirectHandlerSecureHash($array, $secureHash=null) {
        if(!session_id()){
            session_start();
        }
        $authenticationToken = $secureHash?$secureHash:$_SESSION['auth_token'];

        ksort($array);
        $orderedString = $authenticationToken;

        // encoding parameters 
        $encoding_parameters = array();
        $encoding_parameters[] = "Response.StatusDescription";
        $encoding_parameters[] = "Response.GatewayStatusDescription";
        $encoding_parameters[] = "Response_StatusDescription";
        $encoding_parameters[] = "Response_GatewayStatusDescription";

        foreach ($array as $k => $param) {
            if (in_array($k, $encoding_parameters)) {

                $orderedString .= urlencode($param);
            } else {
                $orderedString .= $param;
            }
        }

        $secureHash = hash('sha256', $orderedString, false);

        return $secureHash;
    }

    public static function smartroute_redirect_form($message, $order_number, $order_total, $tranID, $order_status, $type='success') {
        
        echo '<link rel="stylesheet" href="' . WP_PLUGIN_URL . DIRECTORY_SEPARATOR . SmartRoute_Redirect::$PLUGIN_FOLDER_NAME . DIRECTORY_SEPARATOR . 'bootstrap-customized.css">';

        echo '<div class = "panel-group" style="margin-bottom: 50px">';
        echo '<div class = "panel panel-default">';
        echo '<div class="panel-default">';
        echo '<div class="panel-body">';
        echo '<div class="col-sm-12">';
        echo '<div class="col-sm-12 noPadding">';
        echo '<div class="woocommerce-'.$type.'">' . $message . '</div>';
        echo '';
        echo '<table>';
        echo '<tr>';
        echo '<th><label class="control-label">'.__('Order Status', 'woocommerce-smartroute-direct-post-gateway').': </label></th>';
        echo '<td><label class="control-label">' . __($order_status, 'woocommerce-smartroute-redirect-gateway') . '</label></td>';
        echo '</tr>';
        echo '<tr>';
        echo '<th><label class="control-label">'.__('Order ID', 'woocommerce-smartroute-direct-post-gateway').': </label></th>';
        echo '<td><label class="control-label">' . $order_number . '</label></td>';
        echo '</tr>';
        echo '<tr>';
        echo '<th><label class="control-label">'.__('Transaction ID', 'woocommerce-smartroute-direct-post-gateway').': </label></th>';
        echo '<td><label class="control-label">' . $tranID . '</label></td>';
        echo '</tr>';
        
        
        echo '</table>';
//        echo '';
//        echo '<div class="col-sm-12">';
//        echo '<label class="control-label">Date: </label>';
//        echo '<label class="control-label">' . date("Y-m-d") . '</label>';
//        echo '</div>';
//        if ($order_total != '') {
//            echo '';
//            echo '<div class="col-sm-12">';
//            echo '<label class="control-label">Total: </label>';
//            echo '<label class="control-label">' . $order_total . '</label>';
//            echo '</div>';
//            echo '';
//        }
//        echo '<div class="col-sm-12">';
//        echo '<label class="control-label">Payment Method: </label>';
//        echo '<label class="control-label"> SmartRoute Direct Post </label>';
//        echo '</div>';
//        echo '';
        echo '</div>';
        echo '</div>';
        echo '</div>';
        echo '</div>';
        echo '</div>';
        echo '</div>';	

    }

    public function get_return_url($order = null) {
        if ($order) {
            $return_url = $order->get_checkout_order_received_url();
        } else {
            $return_url = wc_get_endpoint_url('order-received', '', wc_get_page_permalink('checkout'));
        }

        if (is_ssl() || get_option('woocommerce_force_ssl_checkout') == 'yes') {
            $return_url = str_replace('http:', 'https:', $return_url);
        }

        return apply_filters('woocommerce_get_return_url', $return_url, $order);
    }

}

?>
