<?php

	require_once 'woocommerce-smartroute-redirect-helper.php';
	
	require_once 'woocommerce-smartroute-redirect.php';
	
	global $woocommerce;
	session_start();

	$orderId = $_SESSION['order_id'];
	$order = new WC_Order($orderId);
	$_SESSION['smartRouteEntered'] = true;
	$data = array();

	$gateway = new SmartRoute_Redirect();
	$gateway->log('redirect response for order#'.$orderId.': '.json_encode($_REQUEST));

	//get required params from response
	if (isset($_REQUEST['Response_StatusCode'])) {
		$data['Response.StatusCode'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_StatusCode']);
	}
	if (isset($_REQUEST['Response_StatusDescription'])) {
		$data['Response.StatusDescription'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_StatusDescription']);
	}
	if (isset($_REQUEST['Response_Amount'])) {
		$data['Response.Amount'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_Amount']);
	}
	if (isset($_REQUEST['Response_CurrencyISOCode'])) {
		$data['Response.CurrencyISOCode'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_CurrencyISOCode']);
	}
	if (isset($_REQUEST['Response_MerchantID'])) {
		$data['Response.MerchantID'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_MerchantID']);
	}
	if (isset($_REQUEST['Response_TransactionID'])) {
		$data['Response.TransactionID'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_TransactionID']);
	}
	if (isset($_REQUEST['Response_MessageID'])) {
		$data['Response.MessageID'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_MessageID']);
	}


	//get optional params from response
	if (isset($_REQUEST['Response_CardExpiryDate'])) {
		$data['Response.CardExpiryDate'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_CardExpiryDate']);
	}

	if (isset($_REQUEST['Response_CardHolderName'])) {
		$data['Response.CardHolderName'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_CardHolderName']);
	}

	if (isset($_REQUEST['Response_CardNumber'])) {
		$data['Response.CardNumber'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_CardNumber']);
	}

	if (isset($_REQUEST['Response_GatewayStatusCode'])) {
		$data['Response.GatewayStatusCode'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_GatewayStatusCode']);
	}

	if (isset($_REQUEST['Response_GatewayStatusDescription'])) {
		$data['Response.GatewayStatusDescription'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_GatewayStatusDescription']);
	}

	if (isset($_REQUEST['Response_GatewayName'])) {
		$data['Response.GatewayName'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_GatewayName']);
	}

	if (isset($_REQUEST['Response_RRN'])) {
		$data['Response.RRN'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_RRN']);
	}

	if (isset($_REQUEST['Response_ApprovalCode'])) {
		$data['Response.ApprovalCode'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_ApprovalCode']);
	}

	if (isset($_REQUEST['Response_Token'])) {
		$data['Response.Token'] = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_Token']);
	}


	$success = false;
	$is_inq = false;

	// get the secure hash
	$secureHash = SmartRoute_Redirect_Helper::generateRedirectHandlerSecureHash($data);        
	$Response_SecureHash = SmartRoute_Redirect_Helper::checkIfNull($_REQUEST['Response_SecureHash']);
	
        $statusDescription = $_REQUEST['Response_StatusDescription'];	

	if ($secureHash == $Response_SecureHash) {
		$gateway->log('redirect secure hash for order#'.$orderId.' match successfully ');
		if ($data['Response.StatusCode'] == "00000") {
			$success = true;
		}
	}elseif($order->get_status() == 'pending'){

		$gateway->log('redirect secure hash for order#'.$orderId.
			" not match ".$secureHash." | ".$Response_SecureHash);
		//Inquiry Message
		$is_inq = true;
		
		$inq_url = trim(SmartRoute_Redirect::$invalidSecureHashInquiryURL);
		
		$fields = array();
		$fields['MessageID'] = 2;
		$fields['MerchantID'] = $data['Response.MerchantID'];
		$fields['OriginalTransactionID'] = $data['Response.TransactionID'];
		$fields['SecureHash'] = SmartRoute_Redirect_Helper::generateRedirectHandlerSecureHash
						($fields);

		$gateway->log('redirect inquiry for order#'.$orderId.
			" : ".json_encode($fields));
		$inq_response = wp_remote_post($inq_url, array(//here
			'method' => 'POST',
			'body' => http_build_query($fields),
			'timeout' => 90,
			'sslverify' => false,
		));

		// Retrieve the body's resopnse if no errors found
		$inq_response_body = wp_remote_retrieve_body($inq_response);
		$gateway->log('redirect inquiry response for order#'.$orderId.
			" : ".$inq_response_body );

        $inq_resp = array();
		// Parse the response into something we can read                
		parse_str($inq_response_body,$inq_resp);

                $inq_res_data = array_map(function($item){
                    return SmartRoute_Redirect_Helper::checkIfNull($item);
                },$inq_resp);
                unset($inq_res_data['Response_SecureHash']);

		// get the secure hash
		$res_secure_hash = SmartRoute_Redirect_Helper::checkIfNull($inq_resp['Response_SecureHash']);
		$newSecureHash = SmartRoute_Redirect_Helper::generateRedirectHandlerSecureHash($inq_res_data);
                $statusDescription = $inq_res_data['Response_StatusDescription'];
		if ($newSecureHash == $res_secure_hash) {
			if ($inq_res_data['Response_StatusCode'] == "00000") {
				$success = true;
			}
		} else {
			// do nothing
		}
	}elseif($order->get_status() == 'completed'){
            $gateway->log('order#'.$orderId.' is already completed');
            $success = true;
        }else{
            $gateway->log('order#'.$orderId.' is already '.$order->get_status());
            $success = false;
        }
        
	//update order status id
	if ($is_inq) {
                $statusDescription = $inq_res_data['Response_StatusDescription'];
		if($success){                         
			$order->update_status(SmartRoute_Redirect_Helper::getOrderStatusId($inq_res_data['Response_StatusCode']));
		} else{ // If the inquiry response secure hash is not match, then update order status as  'pending'
			$order->update_status('pending','order_note');
		}
	} else {
                $statusDescription = $data['Response.StatusDescription'];
		$order->update_status(SmartRoute_Redirect_Helper::getOrderStatusId($data['Response.StatusCode']));
	}
	
        $status_message = __($statusDescription, 'woocommerce-smartroute-redirect-gateway');
        
	if ($success) {
		$order->add_order_note(__('SmartRoute Redirect Payment completed.', 'smartroute-redirect'));

		// Empty the cart (Very important step)
		$woocommerce->cart->empty_cart();

		// redirect to thank you page
		
		unset($_SESSION['smartRouteEntered']);
		
                $old_wc = version_compare( WC_VERSION, '3.0', '<' );
                $order_total = $old_wc ? $order->order_total : $order->get_total();                
		SmartRoute_Redirect_Helper::smartroute_redirect_form($status_message, $order->get_order_number(), $order_total, $data['Response.TransactionID'], $order->get_status(),'message');
	} else {		
		unset($_SESSION['smartRouteEntered']);		
		SmartRoute_Redirect_Helper::smartroute_redirect_form($status_message, $order->get_order_number(), '', $data['Response.TransactionID'], $order->get_status(), 'error');
	}
